.model small
.386
.387

;----------------------------------------------
.data	;Declaraao de variaveis
;----------------------------------------------

  menu_title db "Menu:$"
  menu_1 db "Calcular a equacao$"
  menu_2 db "Acerca do programa$"
  menu_3 db "Sair$"
  seta_y_old db "  $"
  seta_y db "=>$"

  acerca_prog db "Trabalho realizado por:",10,13
	      db "  Eduardo Dias         - no7135",10,13
	      db "  Joao Paulo Fernandes - no7138$"

  equa db "x + y + (x * y) - z - z",10,13,"$"
  introX db "Introduza x(0 a 9): $"
  introY db "Introduza y(0 a 9): $"
  introZ db "Introduza z(0 a 9): $"
  result db "Resultado: $"

  y_min DB 10
  y_max DB 12
  y_ DB 10 	;=y_min
  y_old DB 10 	;=y_min

  temp dw ?
  x dw ?
  y dw ?
  z dw ?

;----------------------------------------------
.code		;inicio do codigo
;----------------------------------------------

;----------------------------------------------
;--------------------MACROS--------------------
;----------------------------------------------
  ClrScr MACRO
    mov ax,12h	;640x480 16 color
    int 10h
  endm
;---------------------------
  Cursor MACRO px, py
    xor bh,bh
    mov dh, py
    mov dl, px
    mov ah,02h
    int 10h
  endm
;---------------------------
  WaitKeyPressed MACRO
    push ax
    mov ah,08h
    int 21h
    pop ax
  endm
;----------------------------------------------
  PutCaract macro ch
    push ax
    push dx
    mov dl, ch
    mov ah, 02h
    int 21h
    pop dx
    pop ax
  endm
;----------------------------------------------
  PutString macro str
    push ax
    push dx
    mov ax, SEG str	; Move o segmento onde str est 
    mov ds,ax		; para AX, e agora para DS
    mov dx, OFFSET str	; DX = Offset de str
    mov ah, 9h		; Subfuno de imprimir strings
    int 21h
    pop dx
    pop ax
  endm
;----------------------------------------------
;----------------PROCEDURES--------------------
;----------------------------------------------
Menu PROC
  ClrScr
  Cursor 7, 9
  PutString menu_title
  Cursor 8, 10
  PutString menu_1
  Cursor 8, 11
  PutString menu_2
  Cursor 8, 12
  PutString menu_3

escolha_menu:
  Cursor 6, y_old
  PutString seta_y_old
  Cursor 6, y_
  PutString seta_y
  mov al, y_
  mov y_old, al		;y_old=y

  mov ah,00h
  int 16H		;l uma tecla

  cmp ah, 48h		;se a tecla  arrow up
  jne endif1
  mov bl, y_
  cmp bl, y_min
  jle endif1
  dec y_

endif1:

  cmp ah, 50h		;se a tecla  arrow down
  jne endif2
  mov bl, y_
  cmp bl, y_max
  jge endif2
  inc y_

endif2:

  cmp al, 13
  jne escolha_menu	;repete a escolha se a tecla carregada no for ENTER

  mov bl, y_
  mov bh, y_min
  sub bl,bh
  inc bl		; bl  a opo escolhida

  ret
Menu ENDP
;----------------------------------------------
;----------------------------------------------
Acerca PROC
  ClrScr
  Cursor 8, 9
  PutString acerca_prog
  WaitKeyPressed
  ret
Acerca ENDP
;----------------------------------------------
;----------------------------------------------
Equacao PROC
  ClrScr
  Cursor 0, 0
  PutString equa

introduz_X:
  Cursor 0, 4
  PutString introX	; "Introduz x(0 a 9):"

  mov ah,01h		; funcao 01h
  int 21h		; pede um caracter

  cmp al, 30h
  jl  introduz_X
  cmp al, 39h		; se o caracter nao estiver
  jg  introduz_X	; entre 0 e 9 entao repete

  sub al,30h		; retira o ASCII
  xor ah, ah		; AH a zeros
  mov x, ax

introduz_Y:
  Cursor 0, 5
  PutString introY	; "Introduz y(0 a 9):"

  mov ah,01h		; funcao 01h
  int 21h		; pede um caracter

  cmp al, 30h
  jl  introduz_Y
  cmp al, 39h		; se o caracter nao estiver
  jg  introduz_Y	; entre 0 e 9 entao repete

  sub al,30h		; retira o ASCII
  xor ah, ah		; AH a zeros
  mov y, ax

introduz_Z:
  Cursor 0, 6
  PutString introZ	; "Introduz z(0 a 9):"

  mov ah,01h		; funcao 01h
  int 21h		; pede um caracter

  cmp al, 30h
  jl  introduz_Z
  cmp al, 39h		; se o caracter nao estiver
  jg  introduz_Z	; entre 0 e 9 entao repete

  sub al,30h		; retira o ASCII
  xor ah, ah		; AH a zeros
  mov z, ax

  Cursor 0, 7
  PutString result

;-----------------Co-Processador---------------
;----------------------------------------------
  finit			;Inicia o Co-Processador Matemtico
  wait
  fild z		; ST(0) = z
  fiadd z		; ST(0) += z , ou seja, ST(0) = z+z
  fild x		; ST(0) = x
  fimul	y		; ST(0) = ST(0) * y = x*y
  fiadd y		; ST(0) += y , ou seja, ST(0) = y+(x*Y)
  fiadd x		; ST(0) += x , ou seja, ST(0) = x+y+(x*Y)

  fcom st(1)		; Compara [x+y+(x*y)] com (z+z)
  fstsw ax
  sahf
  jb Rneg		; se o resultado der negativo, salta para Rneg
  jmp resultado

;----Se o resultado  negativo, ento----------
Rneg:
  fxch st(1)		; troca o valor de ST(0) pelo o valor de ST(1)
  PutCaract '-'

resultado:
  fsub st(0), st(1)	; ST(0) -= temp , ou seja:
			; ST(0) = (x+y+(x*y)) - (z+z) se resultado positivo
			; ST(0) = (z+z) - (x+y+(x*y)) se resultado negativo
  fistp temp		; temp = resultado final

;---Transforma o resultado de dois digitos em ASCII---
  xor dx,dx
  mov ax,temp
  mov cx,10
  div cx	; quociente em ax e o resto em dx
  add al,30h
  add dl,30h

  PutCaract al
  PutCaract dl
  WaitKeyPressed
  ret
Equacao ENDP
;----------------------------------------------
;----------------------------------------------
;----------------------------------------------
main:
  call Menu
  push bx
  
  cmp bl, 1
  je CASE_1
  cmp bl, 2
  je CASE_2
  jmp CASE_END

CASE_1:
  call Equacao
  jmp CASE_END

CASE_2:
  call Acerca
  jmp CASE_END

CASE_END:

  pop bx
  cmp bl, 3
  jne main

;---------------Sair do programa---------------

  mov ax,03	; Modo Texto
  int 10h

  mov ax, 4c00h	; Sair para o DOS
  int 21h

end main